#
import numpy
from scipy.stats import norm

#


#
def binom_confidence(y_score, rho, alpha):

    confidence_interval = [numpy.nan, numpy.nan]

    p = y_score.mean()
    pdf = norm().pdf
    cdf = norm().cdf
    qf = norm().ppf

    delta = qf((1 - (alpha / 2))) * ((p * (1 - p) / y_score.shape[0]) ** 0.5)
    confidence_interval[0], confidence_interval[1] = p - delta, p + delta

    if rho != 0:

        q = cdf((((rho ** 0.5) * qf((1 - alpha)) + qf(p)) / ((1 - rho) ** 0.5)))
        ub = q + (1 / (2 * y_score.shape[0])) * (2 * q - 1 + q * (1 - q) * (((2 * rho - 1) * qf(alpha) - qf(p) * (rho ** 0.5)) / ((rho * (1 - rho)) ** 0.5))
                                                 / pdf((((rho ** 0.5) * qf(alpha) - qf(p)) / ((1 - rho) ** 0.5))))
        confidence_interval[1] = ub

    return confidence_interval
