#
from cr_tools.tests.tests import BinomialTest, BinomialTestCI


#
def binomial_on_binned(y_true_binned, y_score_binned):

    statistics, p_values = [], []

    for j in range(len(y_true_binned)):

        p = y_score_binned[j].mean()
        tst = BinomialTest(p=p)
        nd = sum(y_true_binned[j])
        stat = tst.calculate_statistic(x=nd)
        p_val = tst.calculate_p_value(stated=stat)

        statistics.append(stat)
        p_values.append(p_val)

    return statistics, p_values


def binomial_ci_on_binned(y_true_binned, y_score_binned, rhos, alpha):

    lbs, ubs, results = [], [], []

    for j in range(len(y_true_binned)):

        tst = BinomialTestCI()
        ci = tst.calculate_confidence_interval(y_score=y_score_binned[j], rho=rhos[j], alpha=alpha)
        res = tst.check(y_true=y_true_binned[j], confidence_interval=ci)

        lbs.append(ci[0])
        ubs.append(ci[1])
        results.append(res)

    return lbs, ubs, results


def binomial_ci_bc_on_binned(y_true_binned, y_score_binned, rhos, alpha, ct):

    lbs, ubs, results = [], [], []

    dr = sum([y_true_binned[j].sum() for j in range(len(y_true_binned))]) / sum([len(y_true_binned[j]) for j in range(len(y_true_binned))])
    for j in range(len(y_true_binned)):

        tst = BinomialTestCI()
        ci = tst.calculate_confidence_interval(y_score=y_score_binned[j], rho=rhos[j], alpha=alpha)
        res = tst.check_bc(y_true=y_true_binned[j], confidence_interval=ci, ct=ct, dr=dr)

        lbs.append(ci[0])
        ubs.append(ci[1])
        results.append(res)

    return lbs, ubs, results
