#
import numpy
from matplotlib import pyplot
from sklearn.metrics import roc_curve as roc_curve_sk


#


#
def roc_curve(y_true, y_score):
    fpr, tpr, thresholds = roc_curve_sk(y_true=y_true, y_score=y_score)
    tt = numpy.linspace(start=0, stop=1, num=len(fpr))
    pyplot.plot(fpr, tpr, label='Current Model')
    pyplot.plot(tt, tt, label='Random Model')
    pyplot.legend()
    pyplot.show()


def fish_eye(y_true, y_score, event_label=1):
    events_mask = y_true == event_label
    non_events_mask = y_true != event_label
    pyplot.hist(y_score[events_mask], density=True, histtype='step', cumulative=True, label='Events')
    pyplot.hist(y_score[non_events_mask], density=True, histtype='step', cumulative=True, label='Non-Events')
    pyplot.legend()
    pyplot.show()
